import { EventEmitter } from '@angular/core';
import { SkyHrefChange } from './types/href-change';
import { SkyHrefQueryParams } from './types/href-query-params';
import * as i0 from "@angular/core";
export declare class SkyHrefDirective {
    #private;
    /**
     * Provide a link as a string or as an array of strings to be joined by a slash to form a complete
     * URL.
     *
     * @param skyHref
     */
    set skyHref(skyHref: string | string[] | undefined);
    get skyHref(): string;
    /**
     * A collection of query URL parameters.
     */
    set queryParams(value: SkyHrefQueryParams | undefined);
    get queryParams(): SkyHrefQueryParams | undefined;
    /**
     * Set the behavior for when the link is not available to either hide the link or display unlinked text.
     *
     * @param value
     */
    set skyHrefElse(value: 'hide' | 'unlink' | undefined);
    get skyHrefElse(): 'hide' | 'unlink' | undefined;
    /**
     * Emits whether the link is available (true) or not (false).
     */
    skyHrefChange: EventEmitter<SkyHrefChange>;
    onClick(button: number, ctrlKey: boolean, shiftKey: boolean, altKey: boolean, metaKey: boolean): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyHrefDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SkyHrefDirective, "[skyHref]", never, { "skyHref": { "alias": "skyHref"; "required": false; }; "queryParams": { "alias": "queryParams"; "required": false; }; "skyHrefElse": { "alias": "skyHrefElse"; "required": false; }; }, { "skyHrefChange": "skyHrefChange"; }, never, never, false, never>;
}
