import { HarnessPredicate } from '@angular/cdk/testing';
import { SkyComponentHarness } from '@skyux/core/testing';
import { SkyHrefHarnessFilters } from './href-harness-filters';
/**
 * Allows interaction with a SkyHref directive during testing.
 */
export declare class SkyHrefHarness extends SkyComponentHarness {
    /**
     * @internal
     */
    static hostSelector: string;
    /**
     * Gets a `HarnessPredicate` that can be used to search for a
     * `SkyHrefHarness` that meets certain criteria.
     */
    static with(filters: SkyHrefHarnessFilters): HarnessPredicate<SkyHrefHarness>;
    /**
     * Gets the href attribute of the host element.
     */
    getHref(): Promise<string | null>;
    /**
     * Gets the visible text.
     */
    getText(): Promise<string>;
    /**
     * Returns true if the text is visible.
     */
    isVisible(): Promise<boolean>;
}
